# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from arni_msgs/HostStatistics.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class HostStatistics(genpy.Message):
  _md5sum = "bae87b332f45abad801b7179afd18216"
  _type = "arni_msgs/HostStatistics"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ip of the host  
string host

# the statistics apply to this time window
time window_start
time window_stop

# cpu 
# temp for whole cpu in celsius 
float32 cpu_temp_mean
float32 cpu_temp_stddev
float32 cpu_temp_max

# usage for whole cpu in percent
float32 cpu_usage_mean
float32 cpu_usage_stddev
float32 cpu_usage_max

#cpu usage per core in percent
float32[] cpu_usage_core_mean
float32[] cpu_usage_core_stddev
float32[] cpu_usage_core_max

# temp per core, in celsius
float32[] cpu_temp_core_mean
float32[] cpu_temp_core_stddev
float32[] cpu_temp_core_max


# gpu, placeholder not implemented
# temp in celsius
float32[] gpu_temp_mean
float32[] gpu_temp_stddev
float32[] gpu_temp_max
#usage in percent
float32[] gpu_usage_mean
float32[] gpu_usage_stddev
float32[] gpu_usage_max
 

# ram usage in percent
float32 ram_usage_mean
float32 ram_usage_stddev
float32 ram_usage_max
  
# network
# message_frequency measured in packtes/s
string[] interface_name 
int32[] message_frequency_mean
int32[] message_frequency_stddev
int32[] message_frequency_max

# bandwidth of each network interface
# bytes/s
float32[] bandwidth_mean
float32[] bandwidth_stddev
float32[] bandwidth_max

# drive, free_space in Megabytes
string[] drive_name  
int32[] drive_free_space  
  
# input output operations on a specific drive
# in bytes/s
float32[] drive_read  
float32[] drive_write  
"""
  __slots__ = ['host','window_start','window_stop','cpu_temp_mean','cpu_temp_stddev','cpu_temp_max','cpu_usage_mean','cpu_usage_stddev','cpu_usage_max','cpu_usage_core_mean','cpu_usage_core_stddev','cpu_usage_core_max','cpu_temp_core_mean','cpu_temp_core_stddev','cpu_temp_core_max','gpu_temp_mean','gpu_temp_stddev','gpu_temp_max','gpu_usage_mean','gpu_usage_stddev','gpu_usage_max','ram_usage_mean','ram_usage_stddev','ram_usage_max','interface_name','message_frequency_mean','message_frequency_stddev','message_frequency_max','bandwidth_mean','bandwidth_stddev','bandwidth_max','drive_name','drive_free_space','drive_read','drive_write']
  _slot_types = ['string','time','time','float32','float32','float32','float32','float32','float32','float32[]','float32[]','float32[]','float32[]','float32[]','float32[]','float32[]','float32[]','float32[]','float32[]','float32[]','float32[]','float32','float32','float32','string[]','int32[]','int32[]','int32[]','float32[]','float32[]','float32[]','string[]','int32[]','float32[]','float32[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       host,window_start,window_stop,cpu_temp_mean,cpu_temp_stddev,cpu_temp_max,cpu_usage_mean,cpu_usage_stddev,cpu_usage_max,cpu_usage_core_mean,cpu_usage_core_stddev,cpu_usage_core_max,cpu_temp_core_mean,cpu_temp_core_stddev,cpu_temp_core_max,gpu_temp_mean,gpu_temp_stddev,gpu_temp_max,gpu_usage_mean,gpu_usage_stddev,gpu_usage_max,ram_usage_mean,ram_usage_stddev,ram_usage_max,interface_name,message_frequency_mean,message_frequency_stddev,message_frequency_max,bandwidth_mean,bandwidth_stddev,bandwidth_max,drive_name,drive_free_space,drive_read,drive_write

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HostStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.host is None:
        self.host = ''
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      if self.cpu_temp_mean is None:
        self.cpu_temp_mean = 0.
      if self.cpu_temp_stddev is None:
        self.cpu_temp_stddev = 0.
      if self.cpu_temp_max is None:
        self.cpu_temp_max = 0.
      if self.cpu_usage_mean is None:
        self.cpu_usage_mean = 0.
      if self.cpu_usage_stddev is None:
        self.cpu_usage_stddev = 0.
      if self.cpu_usage_max is None:
        self.cpu_usage_max = 0.
      if self.cpu_usage_core_mean is None:
        self.cpu_usage_core_mean = []
      if self.cpu_usage_core_stddev is None:
        self.cpu_usage_core_stddev = []
      if self.cpu_usage_core_max is None:
        self.cpu_usage_core_max = []
      if self.cpu_temp_core_mean is None:
        self.cpu_temp_core_mean = []
      if self.cpu_temp_core_stddev is None:
        self.cpu_temp_core_stddev = []
      if self.cpu_temp_core_max is None:
        self.cpu_temp_core_max = []
      if self.gpu_temp_mean is None:
        self.gpu_temp_mean = []
      if self.gpu_temp_stddev is None:
        self.gpu_temp_stddev = []
      if self.gpu_temp_max is None:
        self.gpu_temp_max = []
      if self.gpu_usage_mean is None:
        self.gpu_usage_mean = []
      if self.gpu_usage_stddev is None:
        self.gpu_usage_stddev = []
      if self.gpu_usage_max is None:
        self.gpu_usage_max = []
      if self.ram_usage_mean is None:
        self.ram_usage_mean = 0.
      if self.ram_usage_stddev is None:
        self.ram_usage_stddev = 0.
      if self.ram_usage_max is None:
        self.ram_usage_max = 0.
      if self.interface_name is None:
        self.interface_name = []
      if self.message_frequency_mean is None:
        self.message_frequency_mean = []
      if self.message_frequency_stddev is None:
        self.message_frequency_stddev = []
      if self.message_frequency_max is None:
        self.message_frequency_max = []
      if self.bandwidth_mean is None:
        self.bandwidth_mean = []
      if self.bandwidth_stddev is None:
        self.bandwidth_stddev = []
      if self.bandwidth_max is None:
        self.bandwidth_max = []
      if self.drive_name is None:
        self.drive_name = []
      if self.drive_free_space is None:
        self.drive_free_space = []
      if self.drive_read is None:
        self.drive_read = []
      if self.drive_write is None:
        self.drive_write = []
    else:
      self.host = ''
      self.window_start = genpy.Time()
      self.window_stop = genpy.Time()
      self.cpu_temp_mean = 0.
      self.cpu_temp_stddev = 0.
      self.cpu_temp_max = 0.
      self.cpu_usage_mean = 0.
      self.cpu_usage_stddev = 0.
      self.cpu_usage_max = 0.
      self.cpu_usage_core_mean = []
      self.cpu_usage_core_stddev = []
      self.cpu_usage_core_max = []
      self.cpu_temp_core_mean = []
      self.cpu_temp_core_stddev = []
      self.cpu_temp_core_max = []
      self.gpu_temp_mean = []
      self.gpu_temp_stddev = []
      self.gpu_temp_max = []
      self.gpu_usage_mean = []
      self.gpu_usage_stddev = []
      self.gpu_usage_max = []
      self.ram_usage_mean = 0.
      self.ram_usage_stddev = 0.
      self.ram_usage_max = 0.
      self.interface_name = []
      self.message_frequency_mean = []
      self.message_frequency_stddev = []
      self.message_frequency_max = []
      self.bandwidth_mean = []
      self.bandwidth_stddev = []
      self.bandwidth_max = []
      self.drive_name = []
      self.drive_free_space = []
      self.drive_read = []
      self.drive_write = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.host
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4I6f.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.cpu_temp_mean, _x.cpu_temp_stddev, _x.cpu_temp_max, _x.cpu_usage_mean, _x.cpu_usage_stddev, _x.cpu_usage_max))
      length = len(self.cpu_usage_core_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_usage_core_mean))
      length = len(self.cpu_usage_core_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_usage_core_stddev))
      length = len(self.cpu_usage_core_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_usage_core_max))
      length = len(self.cpu_temp_core_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_temp_core_mean))
      length = len(self.cpu_temp_core_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_temp_core_stddev))
      length = len(self.cpu_temp_core_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_temp_core_max))
      length = len(self.gpu_temp_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.gpu_temp_mean))
      length = len(self.gpu_temp_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.gpu_temp_stddev))
      length = len(self.gpu_temp_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.gpu_temp_max))
      length = len(self.gpu_usage_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.gpu_usage_mean))
      length = len(self.gpu_usage_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.gpu_usage_stddev))
      length = len(self.gpu_usage_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.gpu_usage_max))
      _x = self
      buff.write(_struct_3f.pack(_x.ram_usage_mean, _x.ram_usage_stddev, _x.ram_usage_max))
      length = len(self.interface_name)
      buff.write(_struct_I.pack(length))
      for val1 in self.interface_name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.message_frequency_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.message_frequency_mean))
      length = len(self.message_frequency_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.message_frequency_stddev))
      length = len(self.message_frequency_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.message_frequency_max))
      length = len(self.bandwidth_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.bandwidth_mean))
      length = len(self.bandwidth_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.bandwidth_stddev))
      length = len(self.bandwidth_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.bandwidth_max))
      length = len(self.drive_name)
      buff.write(_struct_I.pack(length))
      for val1 in self.drive_name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.drive_free_space)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.drive_free_space))
      length = len(self.drive_read)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.drive_read))
      length = len(self.drive_write)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.drive_write))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host = str[start:end].decode('utf-8')
      else:
        self.host = str[start:end]
      _x = self
      start = end
      end += 40
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.cpu_temp_mean, _x.cpu_temp_stddev, _x.cpu_temp_max, _x.cpu_usage_mean, _x.cpu_usage_stddev, _x.cpu_usage_max,) = _struct_4I6f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_usage_core_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_usage_core_stddev = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_usage_core_max = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_temp_core_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_temp_core_stddev = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_temp_core_max = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_temp_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_temp_stddev = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_temp_max = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_usage_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_usage_stddev = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_usage_max = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 12
      (_x.ram_usage_mean, _x.ram_usage_stddev, _x.ram_usage_max,) = _struct_3f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.interface_name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.interface_name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.message_frequency_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.message_frequency_stddev = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.message_frequency_max = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.bandwidth_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.bandwidth_stddev = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.bandwidth_max = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.drive_name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.drive_name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.drive_free_space = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.drive_read = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.drive_write = struct.unpack(pattern, str[start:end])
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.host
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4I6f.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.cpu_temp_mean, _x.cpu_temp_stddev, _x.cpu_temp_max, _x.cpu_usage_mean, _x.cpu_usage_stddev, _x.cpu_usage_max))
      length = len(self.cpu_usage_core_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_usage_core_mean.tostring())
      length = len(self.cpu_usage_core_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_usage_core_stddev.tostring())
      length = len(self.cpu_usage_core_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_usage_core_max.tostring())
      length = len(self.cpu_temp_core_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_temp_core_mean.tostring())
      length = len(self.cpu_temp_core_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_temp_core_stddev.tostring())
      length = len(self.cpu_temp_core_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_temp_core_max.tostring())
      length = len(self.gpu_temp_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.gpu_temp_mean.tostring())
      length = len(self.gpu_temp_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.gpu_temp_stddev.tostring())
      length = len(self.gpu_temp_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.gpu_temp_max.tostring())
      length = len(self.gpu_usage_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.gpu_usage_mean.tostring())
      length = len(self.gpu_usage_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.gpu_usage_stddev.tostring())
      length = len(self.gpu_usage_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.gpu_usage_max.tostring())
      _x = self
      buff.write(_struct_3f.pack(_x.ram_usage_mean, _x.ram_usage_stddev, _x.ram_usage_max))
      length = len(self.interface_name)
      buff.write(_struct_I.pack(length))
      for val1 in self.interface_name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.message_frequency_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.message_frequency_mean.tostring())
      length = len(self.message_frequency_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.message_frequency_stddev.tostring())
      length = len(self.message_frequency_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.message_frequency_max.tostring())
      length = len(self.bandwidth_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.bandwidth_mean.tostring())
      length = len(self.bandwidth_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.bandwidth_stddev.tostring())
      length = len(self.bandwidth_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.bandwidth_max.tostring())
      length = len(self.drive_name)
      buff.write(_struct_I.pack(length))
      for val1 in self.drive_name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *val1))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.drive_free_space)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.drive_free_space.tostring())
      length = len(self.drive_read)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.drive_read.tostring())
      length = len(self.drive_write)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.drive_write.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host = str[start:end].decode('utf-8')
      else:
        self.host = str[start:end]
      _x = self
      start = end
      end += 40
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.cpu_temp_mean, _x.cpu_temp_stddev, _x.cpu_temp_max, _x.cpu_usage_mean, _x.cpu_usage_stddev, _x.cpu_usage_max,) = _struct_4I6f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_usage_core_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_usage_core_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_usage_core_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_temp_core_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_temp_core_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_temp_core_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_temp_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_temp_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_temp_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_usage_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_usage_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.gpu_usage_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 12
      (_x.ram_usage_mean, _x.ram_usage_stddev, _x.ram_usage_max,) = _struct_3f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.interface_name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.interface_name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.message_frequency_mean = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.message_frequency_stddev = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.message_frequency_max = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.bandwidth_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.bandwidth_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.bandwidth_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.drive_name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.drive_name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.drive_free_space = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.drive_read = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.drive_write = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_4I6f = struct.Struct("<4I6f")
_struct_3f = struct.Struct("<3f")
