# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from arni_msgs/NodeStatistics.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class NodeStatistics(genpy.Message):
  _md5sum = "77e3d99c744be65cba4fc272b34e6dc6"
  _type = "arni_msgs/NodeStatistics"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """#ip of the host this node belongs to
string host

#identifier of this node
string node

# the statistics apply to this time window
time window_start
time window_stop

#CPU
# usage for whole cpu in percent
float32 node_cpu_usage_mean
float32 node_cpu_usage_stddev
float32 node_cpu_usage_max

#usage per core in percent
float32[] node_cpu_usage_core_mean
float32[] node_cpu_usage_core_stddev
float32[] node_cpu_usage_core_max


#GPU, placeholder not implemented
# usage in percent
float32[] node_gpu_usage_mean
float32[] node_gpu_usage_stddev
float32[] node_gpu_usage_max

# ram in percent
float32 node_ramusage_mean
float32 node_ramusage_stddev
float32 node_ramusage_max
  
# network load of the node
# period, in seconds, between messages published
float32 node_message_frequency_mean
float32 node_message_frequency_stddev
float32 node_message_frequency_max

# bandwidth in bytes/ s
float32 node_bandwidth_mean
float32 node_bandwidth_stddev
float32 node_bandwidth_max

# Drive I/O statistics of the node 
#bytes/s
float32 node_write_mean
float32 node_write_stddev
float32 node_write_max

float32 node_read_mean
float32 node_read_stddev
float32 node_read_max
"""
  __slots__ = ['host','node','window_start','window_stop','node_cpu_usage_mean','node_cpu_usage_stddev','node_cpu_usage_max','node_cpu_usage_core_mean','node_cpu_usage_core_stddev','node_cpu_usage_core_max','node_gpu_usage_mean','node_gpu_usage_stddev','node_gpu_usage_max','node_ramusage_mean','node_ramusage_stddev','node_ramusage_max','node_message_frequency_mean','node_message_frequency_stddev','node_message_frequency_max','node_bandwidth_mean','node_bandwidth_stddev','node_bandwidth_max','node_write_mean','node_write_stddev','node_write_max','node_read_mean','node_read_stddev','node_read_max']
  _slot_types = ['string','string','time','time','float32','float32','float32','float32[]','float32[]','float32[]','float32[]','float32[]','float32[]','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       host,node,window_start,window_stop,node_cpu_usage_mean,node_cpu_usage_stddev,node_cpu_usage_max,node_cpu_usage_core_mean,node_cpu_usage_core_stddev,node_cpu_usage_core_max,node_gpu_usage_mean,node_gpu_usage_stddev,node_gpu_usage_max,node_ramusage_mean,node_ramusage_stddev,node_ramusage_max,node_message_frequency_mean,node_message_frequency_stddev,node_message_frequency_max,node_bandwidth_mean,node_bandwidth_stddev,node_bandwidth_max,node_write_mean,node_write_stddev,node_write_max,node_read_mean,node_read_stddev,node_read_max

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NodeStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.host is None:
        self.host = ''
      if self.node is None:
        self.node = ''
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      if self.node_cpu_usage_mean is None:
        self.node_cpu_usage_mean = 0.
      if self.node_cpu_usage_stddev is None:
        self.node_cpu_usage_stddev = 0.
      if self.node_cpu_usage_max is None:
        self.node_cpu_usage_max = 0.
      if self.node_cpu_usage_core_mean is None:
        self.node_cpu_usage_core_mean = []
      if self.node_cpu_usage_core_stddev is None:
        self.node_cpu_usage_core_stddev = []
      if self.node_cpu_usage_core_max is None:
        self.node_cpu_usage_core_max = []
      if self.node_gpu_usage_mean is None:
        self.node_gpu_usage_mean = []
      if self.node_gpu_usage_stddev is None:
        self.node_gpu_usage_stddev = []
      if self.node_gpu_usage_max is None:
        self.node_gpu_usage_max = []
      if self.node_ramusage_mean is None:
        self.node_ramusage_mean = 0.
      if self.node_ramusage_stddev is None:
        self.node_ramusage_stddev = 0.
      if self.node_ramusage_max is None:
        self.node_ramusage_max = 0.
      if self.node_message_frequency_mean is None:
        self.node_message_frequency_mean = 0.
      if self.node_message_frequency_stddev is None:
        self.node_message_frequency_stddev = 0.
      if self.node_message_frequency_max is None:
        self.node_message_frequency_max = 0.
      if self.node_bandwidth_mean is None:
        self.node_bandwidth_mean = 0.
      if self.node_bandwidth_stddev is None:
        self.node_bandwidth_stddev = 0.
      if self.node_bandwidth_max is None:
        self.node_bandwidth_max = 0.
      if self.node_write_mean is None:
        self.node_write_mean = 0.
      if self.node_write_stddev is None:
        self.node_write_stddev = 0.
      if self.node_write_max is None:
        self.node_write_max = 0.
      if self.node_read_mean is None:
        self.node_read_mean = 0.
      if self.node_read_stddev is None:
        self.node_read_stddev = 0.
      if self.node_read_max is None:
        self.node_read_max = 0.
    else:
      self.host = ''
      self.node = ''
      self.window_start = genpy.Time()
      self.window_stop = genpy.Time()
      self.node_cpu_usage_mean = 0.
      self.node_cpu_usage_stddev = 0.
      self.node_cpu_usage_max = 0.
      self.node_cpu_usage_core_mean = []
      self.node_cpu_usage_core_stddev = []
      self.node_cpu_usage_core_max = []
      self.node_gpu_usage_mean = []
      self.node_gpu_usage_stddev = []
      self.node_gpu_usage_max = []
      self.node_ramusage_mean = 0.
      self.node_ramusage_stddev = 0.
      self.node_ramusage_max = 0.
      self.node_message_frequency_mean = 0.
      self.node_message_frequency_stddev = 0.
      self.node_message_frequency_max = 0.
      self.node_bandwidth_mean = 0.
      self.node_bandwidth_stddev = 0.
      self.node_bandwidth_max = 0.
      self.node_write_mean = 0.
      self.node_write_stddev = 0.
      self.node_write_max = 0.
      self.node_read_mean = 0.
      self.node_read_stddev = 0.
      self.node_read_max = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.host
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.node
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4I3f.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.node_cpu_usage_mean, _x.node_cpu_usage_stddev, _x.node_cpu_usage_max))
      length = len(self.node_cpu_usage_core_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.node_cpu_usage_core_mean))
      length = len(self.node_cpu_usage_core_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.node_cpu_usage_core_stddev))
      length = len(self.node_cpu_usage_core_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.node_cpu_usage_core_max))
      length = len(self.node_gpu_usage_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.node_gpu_usage_mean))
      length = len(self.node_gpu_usage_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.node_gpu_usage_stddev))
      length = len(self.node_gpu_usage_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.node_gpu_usage_max))
      _x = self
      buff.write(_struct_15f.pack(_x.node_ramusage_mean, _x.node_ramusage_stddev, _x.node_ramusage_max, _x.node_message_frequency_mean, _x.node_message_frequency_stddev, _x.node_message_frequency_max, _x.node_bandwidth_mean, _x.node_bandwidth_stddev, _x.node_bandwidth_max, _x.node_write_mean, _x.node_write_stddev, _x.node_write_max, _x.node_read_mean, _x.node_read_stddev, _x.node_read_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host = str[start:end].decode('utf-8')
      else:
        self.host = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.node = str[start:end].decode('utf-8')
      else:
        self.node = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.node_cpu_usage_mean, _x.node_cpu_usage_stddev, _x.node_cpu_usage_max,) = _struct_4I3f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_cpu_usage_core_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_cpu_usage_core_stddev = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_cpu_usage_core_max = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_gpu_usage_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_gpu_usage_stddev = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_gpu_usage_max = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 60
      (_x.node_ramusage_mean, _x.node_ramusage_stddev, _x.node_ramusage_max, _x.node_message_frequency_mean, _x.node_message_frequency_stddev, _x.node_message_frequency_max, _x.node_bandwidth_mean, _x.node_bandwidth_stddev, _x.node_bandwidth_max, _x.node_write_mean, _x.node_write_stddev, _x.node_write_max, _x.node_read_mean, _x.node_read_stddev, _x.node_read_max,) = _struct_15f.unpack(str[start:end])
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.host
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.node
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4I3f.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.node_cpu_usage_mean, _x.node_cpu_usage_stddev, _x.node_cpu_usage_max))
      length = len(self.node_cpu_usage_core_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.node_cpu_usage_core_mean.tostring())
      length = len(self.node_cpu_usage_core_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.node_cpu_usage_core_stddev.tostring())
      length = len(self.node_cpu_usage_core_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.node_cpu_usage_core_max.tostring())
      length = len(self.node_gpu_usage_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.node_gpu_usage_mean.tostring())
      length = len(self.node_gpu_usage_stddev)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.node_gpu_usage_stddev.tostring())
      length = len(self.node_gpu_usage_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.node_gpu_usage_max.tostring())
      _x = self
      buff.write(_struct_15f.pack(_x.node_ramusage_mean, _x.node_ramusage_stddev, _x.node_ramusage_max, _x.node_message_frequency_mean, _x.node_message_frequency_stddev, _x.node_message_frequency_max, _x.node_bandwidth_mean, _x.node_bandwidth_stddev, _x.node_bandwidth_max, _x.node_write_mean, _x.node_write_stddev, _x.node_write_max, _x.node_read_mean, _x.node_read_stddev, _x.node_read_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host = str[start:end].decode('utf-8')
      else:
        self.host = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.node = str[start:end].decode('utf-8')
      else:
        self.node = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.node_cpu_usage_mean, _x.node_cpu_usage_stddev, _x.node_cpu_usage_max,) = _struct_4I3f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_cpu_usage_core_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_cpu_usage_core_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_cpu_usage_core_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_gpu_usage_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_gpu_usage_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.node_gpu_usage_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 60
      (_x.node_ramusage_mean, _x.node_ramusage_stddev, _x.node_ramusage_max, _x.node_message_frequency_mean, _x.node_message_frequency_stddev, _x.node_message_frequency_max, _x.node_bandwidth_mean, _x.node_bandwidth_stddev, _x.node_bandwidth_max, _x.node_write_mean, _x.node_write_stddev, _x.node_write_max, _x.node_read_mean, _x.node_read_stddev, _x.node_read_max,) = _struct_15f.unpack(str[start:end])
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_4I3f = struct.Struct("<4I3f")
_struct_15f = struct.Struct("<15f")
