# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from arni_msgs/RatedStatistics.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import arni_msgs.msg

class RatedStatistics(genpy.Message):
  _md5sum = "07568d9eca826510e0314e5125197c7f"
  _type = "arni_msgs/RatedStatistics"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# name of node/host/connection 
string seuid

# only used if seuid is a node. is the host ip the node runs on.
string host  

# the rated statistics apply to statistics from this time window
time window_start
time window_stop

# an array of rated entities
RatedStatisticsEntity[] rated_statistics_entity
================================================================================
MSG: arni_msgs/RatedStatisticsEntity
# type of statistic like cpu_usage_core or cpu_usage
string statistic_type

# the value of the type
string[] actual_value

# the expected value like "40 - 70"
string[] expected_value

# constant
uint8 HIGH=0
uint8 LOW=1
uint8 UNKNOWN=2
uint8 OK=3

# state of the metadata from the node/host/connection : 
# state: { 0 = high ; 1 = low ; 2 = unknown; 3 = ok}  
uint8[] state"""
  __slots__ = ['seuid','host','window_start','window_stop','rated_statistics_entity']
  _slot_types = ['string','string','time','time','arni_msgs/RatedStatisticsEntity[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       seuid,host,window_start,window_stop,rated_statistics_entity

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RatedStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.seuid is None:
        self.seuid = ''
      if self.host is None:
        self.host = ''
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      if self.rated_statistics_entity is None:
        self.rated_statistics_entity = []
    else:
      self.seuid = ''
      self.host = ''
      self.window_start = genpy.Time()
      self.window_stop = genpy.Time()
      self.rated_statistics_entity = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.seuid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.host
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4I.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs))
      length = len(self.rated_statistics_entity)
      buff.write(_struct_I.pack(length))
      for val1 in self.rated_statistics_entity:
        _x = val1.statistic_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.actual_value)
        buff.write(_struct_I.pack(length))
        for val2 in val1.actual_value:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *val2))
          else:
            buff.write(struct.pack('<I%ss'%length, length, val2))
        length = len(val1.expected_value)
        buff.write(_struct_I.pack(length))
        for val2 in val1.expected_value:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *val2))
          else:
            buff.write(struct.pack('<I%ss'%length, length, val2))
        _x = val1.state
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      if self.rated_statistics_entity is None:
        self.rated_statistics_entity = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.seuid = str[start:end].decode('utf-8')
      else:
        self.seuid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host = str[start:end].decode('utf-8')
      else:
        self.host = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs,) = _struct_4I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rated_statistics_entity = []
      for i in range(0, length):
        val1 = arni_msgs.msg.RatedStatisticsEntity()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.statistic_type = str[start:end].decode('utf-8')
        else:
          val1.statistic_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.actual_value = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.actual_value.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.expected_value = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.expected_value.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.state = str[start:end]
        self.rated_statistics_entity.append(val1)
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.seuid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.host
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4I.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs))
      length = len(self.rated_statistics_entity)
      buff.write(_struct_I.pack(length))
      for val1 in self.rated_statistics_entity:
        _x = val1.statistic_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.actual_value)
        buff.write(_struct_I.pack(length))
        for val2 in val1.actual_value:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *val2))
          else:
            buff.write(struct.pack('<I%ss'%length, length, val2))
        length = len(val1.expected_value)
        buff.write(_struct_I.pack(length))
        for val2 in val1.expected_value:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *val2))
          else:
            buff.write(struct.pack('<I%ss'%length, length, val2))
        _x = val1.state
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      if self.rated_statistics_entity is None:
        self.rated_statistics_entity = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.seuid = str[start:end].decode('utf-8')
      else:
        self.seuid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host = str[start:end].decode('utf-8')
      else:
        self.host = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs,) = _struct_4I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rated_statistics_entity = []
      for i in range(0, length):
        val1 = arni_msgs.msg.RatedStatisticsEntity()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.statistic_type = str[start:end].decode('utf-8')
        else:
          val1.statistic_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.actual_value = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.actual_value.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.expected_value = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.expected_value.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.state = str[start:end]
        self.rated_statistics_entity.append(val1)
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_4I = struct.Struct("<4I")
