# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from arni_msgs/StatisticHistoryRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class StatisticHistoryRequest(genpy.Message):
  _md5sum = "59455ce0806ba04af957dd0ac4c49362"
  _type = "arni_msgs/StatisticHistoryRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
time timestamp
"""
  __slots__ = ['timestamp']
  _slot_types = ['time']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StatisticHistoryRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
    else:
      self.timestamp = genpy.Time()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2I.pack(_x.timestamp.secs, _x.timestamp.nsecs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _struct_2I.unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2I.pack(_x.timestamp.secs, _x.timestamp.nsecs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _struct_2I.unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2I = struct.Struct("<2I")
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from arni_msgs/StatisticHistoryResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import arni_msgs.msg
import rosgraph_msgs.msg

class StatisticHistoryResponse(genpy.Message):
  _md5sum = "c2d3c63768f729f21acb750fc902cc4c"
  _type = "arni_msgs/StatisticHistoryResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """


HostStatistics[] host_statistics
RatedStatistics[] rated_host_statistics

NodeStatistics[] node_statistics
RatedStatistics[] rated_node_statistics

rosgraph_msgs/TopicStatistics[] topic_statistics
RatedStatistics[] rated_topic_statistics

================================================================================
MSG: arni_msgs/HostStatistics
# ip of the host  
string host

# the statistics apply to this time window
time window_start
time window_stop

# cpu 
# temp for whole cpu in celsius 
float32 cpu_temp_mean
float32 cpu_temp_stddev
float32 cpu_temp_max

# usage for whole cpu in percent
float32 cpu_usage_mean
float32 cpu_usage_stddev
float32 cpu_usage_max

#cpu usage per core in percent
float32[] cpu_usage_core_mean
float32[] cpu_usage_core_stddev
float32[] cpu_usage_core_max

# temp per core, in celsius
float32[] cpu_temp_core_mean
float32[] cpu_temp_core_stddev
float32[] cpu_temp_core_max


# gpu, placeholder not implemented
# temp in celsius
float32[] gpu_temp_mean
float32[] gpu_temp_stddev
float32[] gpu_temp_max
#usage in percent
float32[] gpu_usage_mean
float32[] gpu_usage_stddev
float32[] gpu_usage_max
 

# ram usage in percent
float32 ram_usage_mean
float32 ram_usage_stddev
float32 ram_usage_max
  
# network
# message_frequency measured in packtes/s
string[] interface_name 
int32[] message_frequency_mean
int32[] message_frequency_stddev
int32[] message_frequency_max

# bandwidth of each network interface
# bytes/s
float32[] bandwidth_mean
float32[] bandwidth_stddev
float32[] bandwidth_max

# drive, free_space in Megabytes
string[] drive_name  
int32[] drive_free_space  
  
# input output operations on a specific drive
# in bytes/s
float32[] drive_read  
float32[] drive_write  

================================================================================
MSG: arni_msgs/RatedStatistics
# name of node/host/connection 
string seuid

# only used if seuid is a node. is the host ip the node runs on.
string host  

# the rated statistics apply to statistics from this time window
time window_start
time window_stop

# an array of rated entities
RatedStatisticsEntity[] rated_statistics_entity
================================================================================
MSG: arni_msgs/RatedStatisticsEntity
# type of statistic like cpu_usage_core or cpu_usage
string statistic_type

# the value of the type
string[] actual_value

# the expected value like "40 - 70"
string[] expected_value

# constant
uint8 HIGH=0
uint8 LOW=1
uint8 UNKNOWN=2
uint8 OK=3

# state of the metadata from the node/host/connection : 
# state: { 0 = high ; 1 = low ; 2 = unknown; 3 = ok}  
uint8[] state
================================================================================
MSG: arni_msgs/NodeStatistics
#ip of the host this node belongs to
string host

#identifier of this node
string node

# the statistics apply to this time window
time window_start
time window_stop

#CPU
# usage for whole cpu in percent
float32 node_cpu_usage_mean
float32 node_cpu_usage_stddev
float32 node_cpu_usage_max

#usage per core in percent
float32[] node_cpu_usage_core_mean
float32[] node_cpu_usage_core_stddev
float32[] node_cpu_usage_core_max


#GPU, placeholder not implemented
# usage in percent
float32[] node_gpu_usage_mean
float32[] node_gpu_usage_stddev
float32[] node_gpu_usage_max

# ram in percent
float32 node_ramusage_mean
float32 node_ramusage_stddev
float32 node_ramusage_max
  
# network load of the node
# period, in seconds, between messages published
float32 node_message_frequency_mean
float32 node_message_frequency_stddev
float32 node_message_frequency_max

# bandwidth in bytes/ s
float32 node_bandwidth_mean
float32 node_bandwidth_stddev
float32 node_bandwidth_max

# Drive I/O statistics of the node 
#bytes/s
float32 node_write_mean
float32 node_write_stddev
float32 node_write_max

float32 node_read_mean
float32 node_read_stddev
float32 node_read_max

================================================================================
MSG: rosgraph_msgs/TopicStatistics
# name of the topic
string topic

# node id of the publisher
string node_pub

# node id of the subscriber
string node_sub

# the statistics apply to this time window
time window_start
time window_stop

# number of messages delivered during the window
int32 delivered_msgs
# numbers of messages dropped during the window
int32 dropped_msgs

# traffic during the window, in bytes
int32 traffic

# mean/stddev/max period between two messages
duration period_mean
duration period_stddev
duration period_max

# mean/stddev/max age of the message based on the
# timestamp in the message header. In case the
# message does not have a header, it will be 0.
duration stamp_age_mean
duration stamp_age_stddev
duration stamp_age_max
"""
  __slots__ = ['host_statistics','rated_host_statistics','node_statistics','rated_node_statistics','topic_statistics','rated_topic_statistics']
  _slot_types = ['arni_msgs/HostStatistics[]','arni_msgs/RatedStatistics[]','arni_msgs/NodeStatistics[]','arni_msgs/RatedStatistics[]','rosgraph_msgs/TopicStatistics[]','arni_msgs/RatedStatistics[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       host_statistics,rated_host_statistics,node_statistics,rated_node_statistics,topic_statistics,rated_topic_statistics

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StatisticHistoryResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.host_statistics is None:
        self.host_statistics = []
      if self.rated_host_statistics is None:
        self.rated_host_statistics = []
      if self.node_statistics is None:
        self.node_statistics = []
      if self.rated_node_statistics is None:
        self.rated_node_statistics = []
      if self.topic_statistics is None:
        self.topic_statistics = []
      if self.rated_topic_statistics is None:
        self.rated_topic_statistics = []
    else:
      self.host_statistics = []
      self.rated_host_statistics = []
      self.node_statistics = []
      self.rated_node_statistics = []
      self.topic_statistics = []
      self.rated_topic_statistics = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.host_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.host_statistics:
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v1 = val1.window_start
        _x = _v1
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v2 = val1.window_stop
        _x = _v2
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_struct_6f.pack(_x.cpu_temp_mean, _x.cpu_temp_stddev, _x.cpu_temp_max, _x.cpu_usage_mean, _x.cpu_usage_stddev, _x.cpu_usage_max))
        length = len(val1.cpu_usage_core_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.cpu_usage_core_mean))
        length = len(val1.cpu_usage_core_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.cpu_usage_core_stddev))
        length = len(val1.cpu_usage_core_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.cpu_usage_core_max))
        length = len(val1.cpu_temp_core_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.cpu_temp_core_mean))
        length = len(val1.cpu_temp_core_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.cpu_temp_core_stddev))
        length = len(val1.cpu_temp_core_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.cpu_temp_core_max))
        length = len(val1.gpu_temp_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.gpu_temp_mean))
        length = len(val1.gpu_temp_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.gpu_temp_stddev))
        length = len(val1.gpu_temp_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.gpu_temp_max))
        length = len(val1.gpu_usage_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.gpu_usage_mean))
        length = len(val1.gpu_usage_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.gpu_usage_stddev))
        length = len(val1.gpu_usage_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.gpu_usage_max))
        _x = val1
        buff.write(_struct_3f.pack(_x.ram_usage_mean, _x.ram_usage_stddev, _x.ram_usage_max))
        length = len(val1.interface_name)
        buff.write(_struct_I.pack(length))
        for val2 in val1.interface_name:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *val2))
          else:
            buff.write(struct.pack('<I%ss'%length, length, val2))
        length = len(val1.message_frequency_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.message_frequency_mean))
        length = len(val1.message_frequency_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.message_frequency_stddev))
        length = len(val1.message_frequency_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.message_frequency_max))
        length = len(val1.bandwidth_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.bandwidth_mean))
        length = len(val1.bandwidth_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.bandwidth_stddev))
        length = len(val1.bandwidth_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.bandwidth_max))
        length = len(val1.drive_name)
        buff.write(_struct_I.pack(length))
        for val2 in val1.drive_name:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *val2))
          else:
            buff.write(struct.pack('<I%ss'%length, length, val2))
        length = len(val1.drive_free_space)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.drive_free_space))
        length = len(val1.drive_read)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.drive_read))
        length = len(val1.drive_write)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.drive_write))
      length = len(self.rated_host_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.rated_host_statistics:
        _x = val1.seuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v3 = val1.window_start
        _x = _v3
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v4 = val1.window_stop
        _x = _v4
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        length = len(val1.rated_statistics_entity)
        buff.write(_struct_I.pack(length))
        for val2 in val1.rated_statistics_entity:
          _x = val2.statistic_type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.actual_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.actual_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          length = len(val2.expected_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.expected_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          _x = val2.state
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.node_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.node_statistics:
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.node
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v5 = val1.window_start
        _x = _v5
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v6 = val1.window_stop
        _x = _v6
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_struct_3f.pack(_x.node_cpu_usage_mean, _x.node_cpu_usage_stddev, _x.node_cpu_usage_max))
        length = len(val1.node_cpu_usage_core_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.node_cpu_usage_core_mean))
        length = len(val1.node_cpu_usage_core_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.node_cpu_usage_core_stddev))
        length = len(val1.node_cpu_usage_core_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.node_cpu_usage_core_max))
        length = len(val1.node_gpu_usage_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.node_gpu_usage_mean))
        length = len(val1.node_gpu_usage_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.node_gpu_usage_stddev))
        length = len(val1.node_gpu_usage_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.node_gpu_usage_max))
        _x = val1
        buff.write(_struct_15f.pack(_x.node_ramusage_mean, _x.node_ramusage_stddev, _x.node_ramusage_max, _x.node_message_frequency_mean, _x.node_message_frequency_stddev, _x.node_message_frequency_max, _x.node_bandwidth_mean, _x.node_bandwidth_stddev, _x.node_bandwidth_max, _x.node_write_mean, _x.node_write_stddev, _x.node_write_max, _x.node_read_mean, _x.node_read_stddev, _x.node_read_max))
      length = len(self.rated_node_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.rated_node_statistics:
        _x = val1.seuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v7 = val1.window_start
        _x = _v7
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v8 = val1.window_stop
        _x = _v8
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        length = len(val1.rated_statistics_entity)
        buff.write(_struct_I.pack(length))
        for val2 in val1.rated_statistics_entity:
          _x = val2.statistic_type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.actual_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.actual_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          length = len(val2.expected_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.expected_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          _x = val2.state
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.topic_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.topic_statistics:
        _x = val1.topic
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.node_pub
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.node_sub
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v9 = val1.window_start
        _x = _v9
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v10 = val1.window_stop
        _x = _v10
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_struct_3i.pack(_x.delivered_msgs, _x.dropped_msgs, _x.traffic))
        _v11 = val1.period_mean
        _x = _v11
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v12 = val1.period_stddev
        _x = _v12
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v13 = val1.period_max
        _x = _v13
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v14 = val1.stamp_age_mean
        _x = _v14
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v15 = val1.stamp_age_stddev
        _x = _v15
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v16 = val1.stamp_age_max
        _x = _v16
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      length = len(self.rated_topic_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.rated_topic_statistics:
        _x = val1.seuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v17 = val1.window_start
        _x = _v17
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v18 = val1.window_stop
        _x = _v18
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        length = len(val1.rated_statistics_entity)
        buff.write(_struct_I.pack(length))
        for val2 in val1.rated_statistics_entity:
          _x = val2.statistic_type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.actual_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.actual_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          length = len(val2.expected_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.expected_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          _x = val2.state
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.host_statistics is None:
        self.host_statistics = None
      if self.rated_host_statistics is None:
        self.rated_host_statistics = None
      if self.node_statistics is None:
        self.node_statistics = None
      if self.rated_node_statistics is None:
        self.rated_node_statistics = None
      if self.topic_statistics is None:
        self.topic_statistics = None
      if self.rated_topic_statistics is None:
        self.rated_topic_statistics = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.host_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.HostStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        _v19 = val1.window_start
        _x = _v19
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v20 = val1.window_stop
        _x = _v20
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.cpu_temp_mean, _x.cpu_temp_stddev, _x.cpu_temp_max, _x.cpu_usage_mean, _x.cpu_usage_stddev, _x.cpu_usage_max,) = _struct_6f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_usage_core_mean = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_usage_core_stddev = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_usage_core_max = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_temp_core_mean = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_temp_core_stddev = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_temp_core_max = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_temp_mean = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_temp_stddev = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_temp_max = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_usage_mean = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_usage_stddev = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_usage_max = struct.unpack(pattern, str[start:end])
        _x = val1
        start = end
        end += 12
        (_x.ram_usage_mean, _x.ram_usage_stddev, _x.ram_usage_max,) = _struct_3f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.interface_name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.interface_name.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.message_frequency_mean = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.message_frequency_stddev = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.message_frequency_max = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.bandwidth_mean = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.bandwidth_stddev = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.bandwidth_max = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.drive_name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.drive_name.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.drive_free_space = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.drive_read = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.drive_write = struct.unpack(pattern, str[start:end])
        self.host_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rated_host_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.RatedStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.seuid = str[start:end].decode('utf-8')
        else:
          val1.seuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        _v21 = val1.window_start
        _x = _v21
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v22 = val1.window_stop
        _x = _v22
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.rated_statistics_entity = []
        for i in range(0, length):
          val2 = arni_msgs.msg.RatedStatisticsEntity()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.statistic_type = str[start:end].decode('utf-8')
          else:
            val2.statistic_type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.actual_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.actual_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.expected_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.expected_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.state = str[start:end]
          val1.rated_statistics_entity.append(val2)
        self.rated_host_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.node_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.NodeStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node = str[start:end].decode('utf-8')
        else:
          val1.node = str[start:end]
        _v23 = val1.window_start
        _x = _v23
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v24 = val1.window_stop
        _x = _v24
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _x = val1
        start = end
        end += 12
        (_x.node_cpu_usage_mean, _x.node_cpu_usage_stddev, _x.node_cpu_usage_max,) = _struct_3f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_cpu_usage_core_mean = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_cpu_usage_core_stddev = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_cpu_usage_core_max = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_gpu_usage_mean = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_gpu_usage_stddev = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_gpu_usage_max = struct.unpack(pattern, str[start:end])
        _x = val1
        start = end
        end += 60
        (_x.node_ramusage_mean, _x.node_ramusage_stddev, _x.node_ramusage_max, _x.node_message_frequency_mean, _x.node_message_frequency_stddev, _x.node_message_frequency_max, _x.node_bandwidth_mean, _x.node_bandwidth_stddev, _x.node_bandwidth_max, _x.node_write_mean, _x.node_write_stddev, _x.node_write_max, _x.node_read_mean, _x.node_read_stddev, _x.node_read_max,) = _struct_15f.unpack(str[start:end])
        self.node_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rated_node_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.RatedStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.seuid = str[start:end].decode('utf-8')
        else:
          val1.seuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        _v25 = val1.window_start
        _x = _v25
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v26 = val1.window_stop
        _x = _v26
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.rated_statistics_entity = []
        for i in range(0, length):
          val2 = arni_msgs.msg.RatedStatisticsEntity()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.statistic_type = str[start:end].decode('utf-8')
          else:
            val2.statistic_type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.actual_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.actual_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.expected_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.expected_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.state = str[start:end]
          val1.rated_statistics_entity.append(val2)
        self.rated_node_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.topic_statistics = []
      for i in range(0, length):
        val1 = rosgraph_msgs.msg.TopicStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.topic = str[start:end].decode('utf-8')
        else:
          val1.topic = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_pub = str[start:end].decode('utf-8')
        else:
          val1.node_pub = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_sub = str[start:end].decode('utf-8')
        else:
          val1.node_sub = str[start:end]
        _v27 = val1.window_start
        _x = _v27
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v28 = val1.window_stop
        _x = _v28
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _x = val1
        start = end
        end += 12
        (_x.delivered_msgs, _x.dropped_msgs, _x.traffic,) = _struct_3i.unpack(str[start:end])
        _v29 = val1.period_mean
        _x = _v29
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v30 = val1.period_stddev
        _x = _v30
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v31 = val1.period_max
        _x = _v31
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v32 = val1.stamp_age_mean
        _x = _v32
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v33 = val1.stamp_age_stddev
        _x = _v33
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v34 = val1.stamp_age_max
        _x = _v34
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.topic_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rated_topic_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.RatedStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.seuid = str[start:end].decode('utf-8')
        else:
          val1.seuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        _v35 = val1.window_start
        _x = _v35
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v36 = val1.window_stop
        _x = _v36
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.rated_statistics_entity = []
        for i in range(0, length):
          val2 = arni_msgs.msg.RatedStatisticsEntity()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.statistic_type = str[start:end].decode('utf-8')
          else:
            val2.statistic_type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.actual_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.actual_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.expected_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.expected_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.state = str[start:end]
          val1.rated_statistics_entity.append(val2)
        self.rated_topic_statistics.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.host_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.host_statistics:
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v37 = val1.window_start
        _x = _v37
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v38 = val1.window_stop
        _x = _v38
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_struct_6f.pack(_x.cpu_temp_mean, _x.cpu_temp_stddev, _x.cpu_temp_max, _x.cpu_usage_mean, _x.cpu_usage_stddev, _x.cpu_usage_max))
        length = len(val1.cpu_usage_core_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.cpu_usage_core_mean.tostring())
        length = len(val1.cpu_usage_core_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.cpu_usage_core_stddev.tostring())
        length = len(val1.cpu_usage_core_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.cpu_usage_core_max.tostring())
        length = len(val1.cpu_temp_core_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.cpu_temp_core_mean.tostring())
        length = len(val1.cpu_temp_core_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.cpu_temp_core_stddev.tostring())
        length = len(val1.cpu_temp_core_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.cpu_temp_core_max.tostring())
        length = len(val1.gpu_temp_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.gpu_temp_mean.tostring())
        length = len(val1.gpu_temp_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.gpu_temp_stddev.tostring())
        length = len(val1.gpu_temp_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.gpu_temp_max.tostring())
        length = len(val1.gpu_usage_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.gpu_usage_mean.tostring())
        length = len(val1.gpu_usage_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.gpu_usage_stddev.tostring())
        length = len(val1.gpu_usage_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.gpu_usage_max.tostring())
        _x = val1
        buff.write(_struct_3f.pack(_x.ram_usage_mean, _x.ram_usage_stddev, _x.ram_usage_max))
        length = len(val1.interface_name)
        buff.write(_struct_I.pack(length))
        for val2 in val1.interface_name:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *val2))
          else:
            buff.write(struct.pack('<I%ss'%length, length, val2))
        length = len(val1.message_frequency_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(val1.message_frequency_mean.tostring())
        length = len(val1.message_frequency_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(val1.message_frequency_stddev.tostring())
        length = len(val1.message_frequency_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(val1.message_frequency_max.tostring())
        length = len(val1.bandwidth_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.bandwidth_mean.tostring())
        length = len(val1.bandwidth_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.bandwidth_stddev.tostring())
        length = len(val1.bandwidth_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.bandwidth_max.tostring())
        length = len(val1.drive_name)
        buff.write(_struct_I.pack(length))
        for val2 in val1.drive_name:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *val2))
          else:
            buff.write(struct.pack('<I%ss'%length, length, val2))
        length = len(val1.drive_free_space)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(val1.drive_free_space.tostring())
        length = len(val1.drive_read)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.drive_read.tostring())
        length = len(val1.drive_write)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.drive_write.tostring())
      length = len(self.rated_host_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.rated_host_statistics:
        _x = val1.seuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v39 = val1.window_start
        _x = _v39
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v40 = val1.window_stop
        _x = _v40
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        length = len(val1.rated_statistics_entity)
        buff.write(_struct_I.pack(length))
        for val2 in val1.rated_statistics_entity:
          _x = val2.statistic_type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.actual_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.actual_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          length = len(val2.expected_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.expected_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          _x = val2.state
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.node_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.node_statistics:
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.node
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v41 = val1.window_start
        _x = _v41
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v42 = val1.window_stop
        _x = _v42
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_struct_3f.pack(_x.node_cpu_usage_mean, _x.node_cpu_usage_stddev, _x.node_cpu_usage_max))
        length = len(val1.node_cpu_usage_core_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.node_cpu_usage_core_mean.tostring())
        length = len(val1.node_cpu_usage_core_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.node_cpu_usage_core_stddev.tostring())
        length = len(val1.node_cpu_usage_core_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.node_cpu_usage_core_max.tostring())
        length = len(val1.node_gpu_usage_mean)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.node_gpu_usage_mean.tostring())
        length = len(val1.node_gpu_usage_stddev)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.node_gpu_usage_stddev.tostring())
        length = len(val1.node_gpu_usage_max)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.node_gpu_usage_max.tostring())
        _x = val1
        buff.write(_struct_15f.pack(_x.node_ramusage_mean, _x.node_ramusage_stddev, _x.node_ramusage_max, _x.node_message_frequency_mean, _x.node_message_frequency_stddev, _x.node_message_frequency_max, _x.node_bandwidth_mean, _x.node_bandwidth_stddev, _x.node_bandwidth_max, _x.node_write_mean, _x.node_write_stddev, _x.node_write_max, _x.node_read_mean, _x.node_read_stddev, _x.node_read_max))
      length = len(self.rated_node_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.rated_node_statistics:
        _x = val1.seuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v43 = val1.window_start
        _x = _v43
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v44 = val1.window_stop
        _x = _v44
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        length = len(val1.rated_statistics_entity)
        buff.write(_struct_I.pack(length))
        for val2 in val1.rated_statistics_entity:
          _x = val2.statistic_type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.actual_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.actual_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          length = len(val2.expected_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.expected_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          _x = val2.state
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.topic_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.topic_statistics:
        _x = val1.topic
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.node_pub
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.node_sub
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v45 = val1.window_start
        _x = _v45
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v46 = val1.window_stop
        _x = _v46
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_struct_3i.pack(_x.delivered_msgs, _x.dropped_msgs, _x.traffic))
        _v47 = val1.period_mean
        _x = _v47
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v48 = val1.period_stddev
        _x = _v48
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v49 = val1.period_max
        _x = _v49
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v50 = val1.stamp_age_mean
        _x = _v50
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v51 = val1.stamp_age_stddev
        _x = _v51
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        _v52 = val1.stamp_age_max
        _x = _v52
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
      length = len(self.rated_topic_statistics)
      buff.write(_struct_I.pack(length))
      for val1 in self.rated_topic_statistics:
        _x = val1.seuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.host
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v53 = val1.window_start
        _x = _v53
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _v54 = val1.window_stop
        _x = _v54
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        length = len(val1.rated_statistics_entity)
        buff.write(_struct_I.pack(length))
        for val2 in val1.rated_statistics_entity:
          _x = val2.statistic_type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.actual_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.actual_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          length = len(val2.expected_value)
          buff.write(_struct_I.pack(length))
          for val3 in val2.expected_value:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *val3))
            else:
              buff.write(struct.pack('<I%ss'%length, length, val3))
          _x = val2.state
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.host_statistics is None:
        self.host_statistics = None
      if self.rated_host_statistics is None:
        self.rated_host_statistics = None
      if self.node_statistics is None:
        self.node_statistics = None
      if self.rated_node_statistics is None:
        self.rated_node_statistics = None
      if self.topic_statistics is None:
        self.topic_statistics = None
      if self.rated_topic_statistics is None:
        self.rated_topic_statistics = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.host_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.HostStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        _v55 = val1.window_start
        _x = _v55
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v56 = val1.window_stop
        _x = _v56
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.cpu_temp_mean, _x.cpu_temp_stddev, _x.cpu_temp_max, _x.cpu_usage_mean, _x.cpu_usage_stddev, _x.cpu_usage_max,) = _struct_6f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_usage_core_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_usage_core_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_usage_core_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_temp_core_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_temp_core_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.cpu_temp_core_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_temp_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_temp_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_temp_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_usage_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_usage_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.gpu_usage_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        _x = val1
        start = end
        end += 12
        (_x.ram_usage_mean, _x.ram_usage_stddev, _x.ram_usage_max,) = _struct_3f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.interface_name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.interface_name.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.message_frequency_mean = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.message_frequency_stddev = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.message_frequency_max = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.bandwidth_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.bandwidth_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.bandwidth_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.drive_name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.drive_name.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.drive_free_space = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.drive_read = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.drive_write = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.host_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rated_host_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.RatedStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.seuid = str[start:end].decode('utf-8')
        else:
          val1.seuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        _v57 = val1.window_start
        _x = _v57
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v58 = val1.window_stop
        _x = _v58
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.rated_statistics_entity = []
        for i in range(0, length):
          val2 = arni_msgs.msg.RatedStatisticsEntity()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.statistic_type = str[start:end].decode('utf-8')
          else:
            val2.statistic_type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.actual_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.actual_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.expected_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.expected_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.state = str[start:end]
          val1.rated_statistics_entity.append(val2)
        self.rated_host_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.node_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.NodeStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node = str[start:end].decode('utf-8')
        else:
          val1.node = str[start:end]
        _v59 = val1.window_start
        _x = _v59
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v60 = val1.window_stop
        _x = _v60
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _x = val1
        start = end
        end += 12
        (_x.node_cpu_usage_mean, _x.node_cpu_usage_stddev, _x.node_cpu_usage_max,) = _struct_3f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_cpu_usage_core_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_cpu_usage_core_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_cpu_usage_core_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_gpu_usage_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_gpu_usage_stddev = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.node_gpu_usage_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        _x = val1
        start = end
        end += 60
        (_x.node_ramusage_mean, _x.node_ramusage_stddev, _x.node_ramusage_max, _x.node_message_frequency_mean, _x.node_message_frequency_stddev, _x.node_message_frequency_max, _x.node_bandwidth_mean, _x.node_bandwidth_stddev, _x.node_bandwidth_max, _x.node_write_mean, _x.node_write_stddev, _x.node_write_max, _x.node_read_mean, _x.node_read_stddev, _x.node_read_max,) = _struct_15f.unpack(str[start:end])
        self.node_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rated_node_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.RatedStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.seuid = str[start:end].decode('utf-8')
        else:
          val1.seuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        _v61 = val1.window_start
        _x = _v61
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v62 = val1.window_stop
        _x = _v62
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.rated_statistics_entity = []
        for i in range(0, length):
          val2 = arni_msgs.msg.RatedStatisticsEntity()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.statistic_type = str[start:end].decode('utf-8')
          else:
            val2.statistic_type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.actual_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.actual_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.expected_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.expected_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.state = str[start:end]
          val1.rated_statistics_entity.append(val2)
        self.rated_node_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.topic_statistics = []
      for i in range(0, length):
        val1 = rosgraph_msgs.msg.TopicStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.topic = str[start:end].decode('utf-8')
        else:
          val1.topic = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_pub = str[start:end].decode('utf-8')
        else:
          val1.node_pub = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_sub = str[start:end].decode('utf-8')
        else:
          val1.node_sub = str[start:end]
        _v63 = val1.window_start
        _x = _v63
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v64 = val1.window_stop
        _x = _v64
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _x = val1
        start = end
        end += 12
        (_x.delivered_msgs, _x.dropped_msgs, _x.traffic,) = _struct_3i.unpack(str[start:end])
        _v65 = val1.period_mean
        _x = _v65
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v66 = val1.period_stddev
        _x = _v66
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v67 = val1.period_max
        _x = _v67
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v68 = val1.stamp_age_mean
        _x = _v68
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v69 = val1.stamp_age_stddev
        _x = _v69
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        _v70 = val1.stamp_age_max
        _x = _v70
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        self.topic_statistics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rated_topic_statistics = []
      for i in range(0, length):
        val1 = arni_msgs.msg.RatedStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.seuid = str[start:end].decode('utf-8')
        else:
          val1.seuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.host = str[start:end].decode('utf-8')
        else:
          val1.host = str[start:end]
        _v71 = val1.window_start
        _x = _v71
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        _v72 = val1.window_stop
        _x = _v72
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.rated_statistics_entity = []
        for i in range(0, length):
          val2 = arni_msgs.msg.RatedStatisticsEntity()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.statistic_type = str[start:end].decode('utf-8')
          else:
            val2.statistic_type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.actual_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.actual_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.expected_value = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8')
            else:
              val3 = str[start:end]
            val2.expected_value.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.state = str[start:end]
          val1.rated_statistics_entity.append(val2)
        self.rated_topic_statistics.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_6f = struct.Struct("<6f")
_struct_2I = struct.Struct("<2I")
_struct_3f = struct.Struct("<3f")
_struct_3i = struct.Struct("<3i")
_struct_15f = struct.Struct("<15f")
_struct_2i = struct.Struct("<2i")
class StatisticHistory(object):
  _type          = 'arni_msgs/StatisticHistory'
  _md5sum = 'cf1c5d964843e655f8093cfe8cc9e33d'
  _request_class  = StatisticHistoryRequest
  _response_class = StatisticHistoryResponse
